
#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "cursor.h"
#include "defines.h"
#include "Functions.h"

CCursor::CCursor() {
    SDL_Surface *Tmp,*Tmp2;
    Tmp = IMG_Load("./graphics/cursor.png");
    if(SCREENPOSMULTIPLY > 1)
    {
        Tmp2 = SDL_DisplayFormat(Tmp);
        SDL_FreeSurface(Tmp);
        PSurface = ScaleSurface(Tmp2,SCREENPOSMULTIPLY);
        SDL_FreeSurface(Tmp2);
    }
    else
    {
        PSurface = SDL_DisplayFormat(Tmp);
        SDL_FreeSurface(Tmp);
    }
    SDL_SetColorKey(PSurface,SDL_SRCCOLORKEY,SDL_MapRGB(PSurface->format,255,0,255));
    MaxAnims = 4;
    NewFrame = 2;
    AnimCounter= 0;
    Anim = 0;
}

CCursor::~CCursor(void) {
    if(PSurface)
        SDL_FreeSurface(PSurface);
}

void CCursor::Draw(SDL_Surface *Surface) {
    SDL_Rect Dst,Src;

    Dst.x = Px * TileWidth;
    Dst.y = Py * TileHeight;
    Dst.w = TileWidth;
    Dst.h = TileHeight;
    Src.x = Anim * TileWidth;
    Src.y = 0;
    Src.w = TileWidth;
    Src.h = TileHeight;
    AnimCounter++;
    if(AnimCounter>NewFrame)
    {
        AnimCounter = 0;
        Anim++;
        if(Anim >= MaxAnims)
            Anim = 0;
    }
    SDL_BlitSurface(PSurface,&Src,Surface,&Dst);

}
