program Project1;

uses
  SDL,
  SDL_Image,
  SDL_TTF,
  SDL_Mixer,
  windows,
  sysutils,
  dialogs,
  Classes,
  inifiles,
  logger;

{$R *.res}
Type
 TGameState = (GSQuit,GSGame,GSStageClear,GSNextStage,GSPasswordEntry,GSTitleScreen,GSCredits,GSStageSelect,GSIntro,GSOldManSpeaking,GSOptions);
 TPlayerState = (Walking,Waiting,Lookingup,EnterBuilding,EnteredBuilding);
 TCloudStyle = (Big,Small);

 TOptionSelector = Class
  Image : PSDL_Surface;
  Selection : integer;
  Constructor Create;
  Destructor Free;
  Procedure Draw;
  Procedure MoveDown;
  Procedure MoveUp;
 end;

 THand = Class
  X,Y,movedelay : integer;
  Hidden : boolean;
  Image : PSDL_Surface;
  Constructor Create;
  Destructor Free;
  Procedure Move;
  Procedure Draw;
 end;

 TPlayer = Class
  X,Y,Animphase,animcounter,delay,Width,Height,minx,maxx : Integer;
  Image,Shadow : PSDL_Surface;
  State : TPlayerState;
  ConStructor Create(Xin,Yin,MinXin,MaxXin : integer);
  Destructor Free;
  Procedure move;
  procedure Draw;
 end;

 TSpaceShip = Class
  X,Y : Integer;
  Image : PSDL_Surface;
  Constructor Create;
  Destructor Free;
  Procedure Move;
  Procedure Draw;
 end;

 TCloud = Class
  X,Xi : Real;
  Y,Width,Height: Integer;
  Image : PSDL_Surface;
  Constructor Create(Xin,Yin : integer;Xiin : real;Style:TCloudStyle);
  Destructor Free;
  Procedure Move;
  Procedure Draw;
 end;

 TPasswordSelector = class
  X,Y : Integer;
  Image : PSDL_Surface;
  Constructor Create;
  Destructor Free;
  procedure moveup;
  procedure movedown;
  procedure moveleft;
  procedure moveright;
  Procedure Draw;
 end;

 TTitleScreenSelector = Class
  X,Selection : integer;
  Image : PSDL_Surface;
  Constructor Create;
  Destructor Free;
  Procedure Moveup;
  procedure MoveDown;
  Procedure Draw;
 end;

 TFairy = Class
  X,Y,Width,Height,Delay,Animphase,AnimDelay : integer;
  Hidden : boolean;
  Image : PSDL_Surface;
  Constructor Create(Xin,Yin,AnimDelayin :integer);
  Destructor Free;
  Procedure Draw;
 end;

 TStageBlock = Class
  X,Y,Yi,Width,Height : integer;
  Hidden : Boolean;
  Image : PSDL_Surface;
  Constructor Create(Blocknr : integer);
  Destructor Free;
  Procedure Draw;
  Procedure Move;
 end;

 TStageSelectSelector = Class
  X,Y,Selection,movedelay : integer;
  Image : PSDL_Surface;
  Constructor Create;
  Destructor free;
  Procedure Draw;
  procedure moveleft;
  procedure moveright;
  procedure moveup;
  procedure movedown;
 end;

Const
 Fps = 30;
 BlockCount = 13; // Nr of diffrent blockparts
 Bordercount = 7; // Nr of diffrent borderparts
 BlockWidth = 25;
 BlockHeight = 25;
 XoffSetGame = 80;  //offset where game needs to start drawing
 YoffSetGame = 68;
 XOffsetPassword = 100;
 YOffsetPassword = 150;
 XoffsetStageSelect = 100;
 YOffsetStageSelect = 100;
 Cols = 20;
 Rows = 16;
 MinPlayareaX = 0+ XoffSetGame;  //playarea dimensions
 MinPlayAreaY = 0+YoffSetGame;
 MaxPlayAreaX = XoffSetGame + BlockWidth * Cols;
 MaxPlayAreaY = YoffSetGame + BlockHeight * Rows;
 LeveLPasswords: Array[1..36] of String = ('DAVY','DISK','TREE','SEAL',
                                           'OPEN','LION','WINE','GROW',
                                           'FOOD','DUEL','MEAT','FLEE',
                                           'DUST','LOST','HELP','MILK',
                                           'SAFE','DULL','SAVE','BEER',
                                           'BILL','BLOW','BIKE','VENT',
                                           'ROOM','HOOD','MOOD','FEAR',
                                           'REEF','POLE','BEEF','SONG',
                                           'HOPE','BLUE','MAIL','MONK');
 LetterRows = 4;
 LetterCols = 7;
 Letters: Array[0..Letterrows -1,0..LetterCols-1] of String =
                                (('A','B','C','D','E','F','G'),
                                 ('H','I','J','K','L','M','N'),
                                 ('O','P','Q','R','S','T','U'),
                                 ('V','W','X','Y','Z','0','0'));
 //Audio
 NROfSounds =10;
 SND_RotateBlock = 1;
 SND_DropBlock = 2;
 SND_FlipBlock = 3;
 SND_PickupBlock = 4;
 SND_Error = 5;
 SND_Menu = 6;
 SND_Select = 7;
 SND_Bridge = 8;
 SND_StageEnd = 9;
 SND_Elf = 10;

 NrofMusic = 5;
 MUS_Title = 1;
 MUS_Game1 = 2;
 MUS_Game2 = 3;
 MUS_Oldman = 4;
 MUS_Stage = 5;

var
 //Main Game Stuff
 GameState : TGameState = GSIntro; // state of the game
 screen: PSDL_Surface; // Screen surface
 Level :integer = 0;
 NextTime : Cardinal;

 //audio
 Sounds : array[1..NrofSounds] of PMIX_Chunk;
 GlobalSoundEnabled: Boolean = true;
 SoundEnabled,MusicEnabled : Boolean;
 channel : integer;

 Music : array[1..NrofMusic] of PMix_Music;
 //Puzzle Game Stuff
 BlockImages : array[1..BlockCount] of PSDL_Surface; // images of blockparts
 BorderImages : array[1..Bordercount] of PSDL_Surface; // images of borderpats
 Playfield : array[0..1,0..Cols-1,0..Rows-1] of integer; //playfield array
 StartTime,EndTime : TDateTime; //Starttime & Endtime of the puzzle
 Font : PTTF_Font;  //Font used to draw text
 HandCursor : THand; // the handcursor
 BlockActive : Boolean; // Blockactive flag

 //Stage Clear Stuff
 RoomBackground,StageClearKader : PSDL_Surface;

 //Next Stage Stuff
 Bridge : PSDL_Surface;


//Common Stuff
Function GetAppPath : String;
begin
 Result := ExtractFilePath(paramstr(0));
end;

Function Waitforframe : cardinal;
var
now : cardinal;
begin
 now := SDL_Getticks;
 if now >= nexttime then
 begin
  result :=0;
  NextTime := now + round(1000/fps);
 end
 else
  Result := NextTime - now;
end;

//procedure to write X nr of letters of a text to a certain Surface in a Certain color
//The function can accept Chr(13) io enters.
Procedure WriteText(Surface:PSDL_Surface;PFont: PTTF_Font;Tekst : String;NrofChars,X,Y,YSpacing : integer;Color : TSDL_Color);
var
 List : TStringlist;
 teller: integer;
 Line : String;
 DstRect : TSDL_Rect;
 tmpSurface : PSDL_Surface;
begin
 line := '';
 List := Tstringlist.Create;
 For teller := 1 to NrofChars do
 begin
  If (Tekst[teller] = chr(13)) then
  begin
   List.Add(line);
   line := '';
  end
  else
   Line := Line + Tekst[teller];
 end;
 if length(line) > 0 then list.Add(line);

 For teller := 0 to List.Count -1 do
 begin
  if length (list[teller]) > 0 then
  begin
   tmpSurface := TTF_RenderText_Solid(Pfont,Pchar(List[teller]),Color);
   DstRect.x := X;
   DstRect.y := Y + (Teller) * TTF_FontLineSkip(Pfont) + (teller*Yspacing);
   DstRect.w := tmpSurface.w;
   DstRect.h := TmpSurface.h;
   SDL_BlitSurface(tmpSurface,nil,Surface,@DstRect);
   SDL_FreeSurface(tmpSurface);
  end;
 end;
 List.Free;
end;
//end of common stuff

//Game Stuff -----------------------------------------------------------
{ THand----------------------------------------------------------------- }
constructor THand.Create;
begin
 Image := Img_load(Pchar(GetAppPath + 'Graphics\' + 'Hand.bmp'));
 SDL_SetColorKey(Image,SDL_SRCCOLORKEY or SDL_RLEACCEL or SDL_HWACCEL,SDL_MapRGB(Image.format,255,0,255));
 Hidden := false;
 X := MinPlayareaX;
 Y := MinPlayareaY;
 movedelay := 0;
end;

procedure THand.Draw;
var
 DstRect : TSDL_Rect;
begin
 DstRect.x := X;
 DstRect.y := Y;
 DstRect.w := Image.w;
 DstRect.h := Image.h;
 if not hidden then Sdl_BlitSurface(Image,nil,Screen,@DstRect);
end;

destructor THand.Free;
begin
 SDL_FreeSurface(Image);
end;

procedure THand.Move;
var
Keys : PKeyStateArr;
begin
 Keys := PKeyStateArr(SDL_GetKeystate(nil));
 if not hidden then
 begin
  inc(movedelay);
  if movedelay = 4 then
  begin
   if keys[SDLK_UP] = 1 then
   begin
    if Y - 25 >= MinPlayareaY then Y := Y - 25;
   end;

   if keys[SDLK_DOWN] = 1 then
   begin
    if Y + 25 < MaxPlayareaY then Y := Y + 25;
   end;

   if keys[SDLK_LEFT] = 1 then
   begin
    if X - 25 >= MinPlayareaX then X := X - 25;
   end;

   if keys[SDLK_RIGHT] = 1 then
   begin
    if X + 25 < MaxPlayareaX then X := X + 25;
   end;

   movedelay := 0;
  end;
 end;
end;

//teken het speelveld
procedure DrawPlayField;
var
Layers,X,Y : Integer;
DstRect : TSDL_Rect;
begin
 For layers := 0 to 1 do
 for X := 0 to Cols - 1 do
  for Y := 0 to Rows - 1 do
   begin
    if Playfield[Layers,X,Y] > 0 then
    begin
     DstRect.x := XoffSetGame + X * BlockWidth;
     DstRect.y := YoffSetGame + Y * BlockHeight;
     DstRect.w := BlockWidth;
     DstRect.h := BlockHeight;
     SDL_BlitSurface(BlockImages[Playfield[Layers,X,Y]],nil,screen,@DstRect);
    end;

    if playfield[Layers,X,Y] < 0 then
    begin
     DstRect.x := XoffSetGame + X * BlockWidth;
     DstRect.y := YoffSetGame + Y * BlockHeight;
     DstRect.w := BlockWidth;
     DstRect.h := BlockHeight;
     SDL_BlitSurface(BorderImages[abs(Playfield[Layers,X,Y])],nil,screen,@DstRect);
    end;
   end;
end;

procedure MoveBlockRight;
var
 x,y: integer;
 CanMove : boolean;
begin
 //als er geen blokje aan de rechterkant staat
 CanMove := true;
 for y := 0 to rows -1 do
  if (playfield[1,Cols-1,Y] <> 0) then
  begin
   CanMove := false;
   break;
  end;
 //zet alles 1 plaats naar rechts op de movementlayer
 If CanMove then
 for x := cols -1 downto 1 do
  for y := 0 to rows -1 do
   playfield[1,X,Y] := playfield[1,x-1,y];
 //zet linkerkant gelijk aan 0
 for y := 0 to rows -1 do
  playfield[1,0,y] := 0;
end;

procedure MoveBlockLeft;
var
 x,y: integer;
 CanMove : boolean;
begin
 //als er geen blokje aan de linkkerkant te vinde is
 CanMove := true;
 for y := 0 to rows -1 do
  if (playfield[1,0,Y] <> 0) then
  begin
   CanMove := false;
   break;
  end;
 //schuif alles 1 plaats naar links op de movement layer
 If CanMove then
 for x := 0 to cols -2 do
  for y := 0 to rows -1 do
   playfield[1,X,Y] := playfield[1,x+1,y];
 //zet alles aan de rechterkant op 0
 for y := 0 to rows -1 do
  playfield[1,cols-1,y] := 0;
end;

procedure MoveBlockup;
var
 x,y: integer;
 CanMove : boolean;
begin
 //als er geen blockje bovenaan te vinden is
 CanMove := true;
 for X := 0 to cols -1 do
  if (playfield[1,X,0] <> 0) then
  begin
   CanMove := false;
   break;
  end;
 //schuif alles 1 plaats naar boven op de movement layer
 If CanMove then
 for x := 0 to cols -1 do
  for y := 0 to rows -2 do
   playfield[1,X,Y] := playfield[1,x,y+1];
 //zet de onderste rij gelijk aan 0 (geen blokjes)
 for x := 0 to cols -1 do
  playfield[1,x,rows-1] := 0;
end;

procedure MoveBlockdown;
var
 x,y: integer;
 CanMove : boolean;
begin
 CanMove := true;
 //als er geen blokje onderaan te vinden is
 for X := 0 to cols -1 do
  if (playfield[1,X,rows-1] <> 0) then
  begin
   CanMove := false;
   break;
  end;
 //schuif alles 1 plaats naar benende op de movement layer (1)
 If CanMove then
 for x := 0 to cols -1 do
  for y := rows-1 downto 1 do
   playfield[1,X,Y] := playfield[1,x,y-1];
 //zet de bovenste rij gelijk aan 0
 for x := 0 to cols -1 do
  playfield[1,x,0] := 0;
end;

// zet alle stukken blok van het blokje naar de movementlayer
procedure MakeBlockActive(x,y,blocknr: integer);
begin
 If (X >= 0) and (Y >= 0) and (X < Cols) and (Y < Rows) then
 if playfield[0,X,Y] = blocknr then
 begin
  playfield[0,x,y] := 0;
  playfield[1,x,y] := blocknr;
  MakeBlockActive(x+1,y,blocknr);
  MakeBlockActive(X,Y+1,blocknr);
  MakeBlockActive(X-1,Y,blocknr);
  MakeBlockActive(X,Y-1,blocknr);
 end;
end;

// Zet alle stukken blok van het blokje naar de bloklayer
// als er het blokje niet over een ander blokje of
// borderstukje ligt
Function MakeBlockUnActive : boolean;
var
 x,y: integer;
 Firstblockfound,UnActive: boolean;
begin
 Firstblockfound := false;
 UnActive := true;
 //check to see if another block is underneath the active block
 for x := 0 to cols -1 do
  for y := 0 to rows -1 do
   if (playfield[1,x,y] > 0) and (playfield[0,x,y] <> 0) then
    UnActive := false;

 if UnActive then
  for x := 0 to cols -1 do
   for y := 0 to rows -1 do
    if playfield[1,x,y] > 0 then
    begin
     if not FirstBlockFound then
     begin
     //set the handcursor to the 1st block found
      handcursor.X := XoffSetGame + X * Blockwidth;
      Handcursor.Y := YoffSetGame + Y * Blockheight;
      firstblockfound := true;
     end;
     //set the block from the movement layer (1) to the blocks layer (0)
     playfield[0,x,y] := playfield[1,x,y];
     playfield[1,x,y] := 0;
    end;
  result := unactive
end;

procedure FlipBlock(Horizontal:boolean);
var
 BlockW,BlockH,x,y,minx,miny,maxx,maxy:integer;
 Tmp : Array[0..cols-1,0..rows-1] of integer;
begin
 //onmogelijke vindwaarden om te starten
 minx := 100;
 miny := 100;
 maxx := -1;
 Maxy := -1;
 //zoek de minimum - maximum, x en y waarden en intializeer de tmp array
 for x := 0 to cols -1 do
  for y := 0 to rows -1 do
  begin
   if playfield[1,x,y] > 0 then
   begin
    if minx > x then minx := x;
    if maxx < x then maxx := x;
    if miny > y then miny := y;
    if maxy < y then maxy := y;
   end;
   tmp[x,y] := 0;
  end;
  BlockW := maxx - minx ;
  BlockH := Maxy - miny ;
  //zet het 'geflipte' blokje in de tmp array
  for x := 0 to blockw  do
   for y := 0 to blockh do
   begin
    if Horizontal then
     tmp[x,blockh - y] := playfield[1,minx+x,miny+y]
    else
     tmp[blockw -x,Y] :=  playfield[1,minx+x,miny+y];
    playfield[1,minx+x,miny+y] := 0;
   end;
  //zet het 'geflipte blokje terug op de movement layer(1)
  for x := 0 to blockw do
   for y := 0 to blockh do
    playfield[1,minx+x,miny+y] := tmp[x,y];
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_FlipBlock],0);
end;

procedure RotateBlock;
var
 Offset,NewBlockW,NewBlockH,BlockW,BlockH,Minx,Miny,Maxx,Maxy,x,y,z : integer;
 Tmp : Array[0..cols-1,0..rows-1] of integer;
begin
 //onmogelijke vindwaarden om te starten
 minx := 100;
 miny := 100;
 maxx := -1;
 Maxy := -1;
 //zoek de minimum - maximum, x en y waarden en intializeer de tmp array
 for x := 0 to cols -1 do
  for y := 0 to rows -1 do
  begin
   if playfield[1,x,y] > 0 then
   begin
    if minx > x then minx := x;
    if maxx < x then maxx := x;
    if miny > y then miny := y;
    if maxy < y then maxy := y;
   end;
   tmp[x,y] := 0;
  end;
 //als het blokje evengrote width & height heeft
 BlockW := maxx - minx +1;
 BlockH := Maxy - miny + 1;
 if BlockW = BlockH then
 begin
  //zet het blokje in de temp array gedraaid
  for x := 0 to BlockW-1 do
   for y := 0 to BlockH-1 do
   begin
    tmp[BlockW-1-y,x] := playfield[1,x+minx,y+miny];
    playfield[1,x+minx,y+miny] := 0;
   end;
  //zet het gedraaide blockje terug op de movement layer (1)
  for x := 0 to BlockW -1 do
   for y := 0 to BlockH -1 do
    playfield[1,minx+x,miny+y] := tmp[x,y];
 end;

 If blockW > Blockh then
 begin
  Newblockh := Blockw;
  if (miny + (newblockh div 2)  >= rows) or (miny - (newblockh-1) div 2 < 0) or (minx + blockw div 2 > cols) then
  begin
   if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_error],0);
   exit;
  end;
  for x := 0 to blockW -1 do
   for y := 0 to blockh -1 do
   begin
    tmp[blockw-1-y,x] := playfield[1,x+minx,y+miny];
    playfield[1,x+minx,y+miny]:= 0;
   end;

  for x := 0 to Blockw -1 do
   for y := 0 to newblockh -1 do
    if (minx+x - (blockw -1) div 2 >= 0) and (minx +x -(blockw-1) div 2 <= cols-1) and
       (miny+y - (newblockh-1) div 2 >= 0) and (miny+y - (newblockh-1) div 2 <= rows -1) then
    playfield[1,minx+x - (blockw -1 ) div 2,miny+y -(newblockh -1) div 2] := tmp[x,y];
 end;

 If blockW < Blockh then
 begin
  NewblockW := BlockH;
  NewBlockH := BlockW;
  //hack for putting 2 blocks on the right place after being rotated;
  if (blockw = 2) and (blockh = 3) then offset := 1 else offset := 0;
  if (minx + offset + newblockw div 2 >= cols) or (minx + offset - (newblockw-1) div 2 < 0) or (miny + (blockh) div 2 > rows)  then
  begin
   if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_error],0);
   exit;
  end;
  for x := 0 to blockW -1 do
   for y := 0 to blockh -1 do
   begin
    tmp[newblockw-1-y,x] := playfield[1,x+minx,y+miny];
    playfield[1,x+minx,y+miny]:= 0;
   end;

  for x := 0 to newBlockw -1 do
   for y := 0 to Newblockh -1 do
    if (minx+x + offset - (newblockw-1) div 2 >= 0) and (minx+x + offset - (newblockw-1) div 2 <= cols-1) and
       (miny+y + (blockh -1) div 2 >= 0) and (miny+y +(blockh-1) div 2 <= rows -1) then
    playfield[1,minx+x +offset -(newblockw -1) div 2,miny+y +(blockh -1) div 2] := tmp[x,y];
 end;
 if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_RotateBlock],0);
end;

Procedure LoadLevel;
var
 x,y,value : integer;
 F:file of integer;
begin
 assignfile(F,GetAppPath + 'levels\level' +inttostr(Level)+ '.lev');
 reset(f);
 for x := 0 to cols -1 do
  for y := 0 to rows -1 do
  begin
   read(f,value);
   playfield[0,x,y] := value;
   Playfield[1,x,y] := 0;
  end;
 closefile(f);
end;

Function IsStageClear: boolean;
var
x,y,tellerx,tellery : integer;
StartBorderfound,vertStartborderfound,VertEndBorderFound,Temp : boolean;
begin
 Temp := True;
 //Hack for level 17
 If level = 17 then
 begin
  For y := 6 to 8 do
   for x := 0 to cols -1 do
    temp := temp and (playfield[0,x,y] > 0);
 end
 else
 //hack for level 32
 if level = 32 then
 begin
  for y := 0 to 14 do
   for x := 7 to 9 do
    temp := temp and (playfield[0,x,y] > 0);
  for y := 6 to 8 do
   for x := 10 to 14 do
    temp := temp and (playfield[0,x,y] > 0);
 end
 else
 begin
  //als er op de X as geen border van de kader gevonden wordt
  StartBorderFound := false;
  for y := 0 to rows -1 do
  for x := 0 to cols -1 do
  begin
   if not StartBorderFound then
   begin
    if X < cols -1 then
    begin
     //kijk of er een stukje border is met daarnaast geen stukje border
     if (playfield[0,x,y] < 0) and (playfield[0,x+1,y] >= 0) then
     begin
      for tellerx := x+1 to cols -1 do
      begin
       //kijk of er verder nog een stukje border te vinden is zoja is
       //er een startborder op de x as gevonden
       if playfield[0,tellerx,y] < 0  then StartBorderFound :=  true;
      end;
     end;
    end;
   end
   else
   begin
    //Als er een (eind)border gevonden wordt startborder false
    //Er Wordt ook gekeken of de eindborder geen nieuwe startborder
    //kan zijn
    if playfield[0,x,y] < 0 then
    begin
     StartBorderfound := false;
     //Eindborder nieuwe startborder ?
     if X < cols -1 then
     begin
      //kijk of er een stukje border is met daarnaast geen stukje border
      if (playfield[0,x,y] < 0) and (playfield[0,x+1,y] >= 0) then
      begin
       for tellerx := x+1 to cols -1 do
       begin
        //kijk of er verder nog een stukje border te vinden is zoja is
        //er een startborder op de x as gevonden
        if playfield[0,tellerx,y] < 0  then StartBorderFound :=  true;
       end;
      end;
     end;
     continue; // Ga naar de volgende X waarde;
    end;
    if StartBorderfound then
    begin
     //wordt gekeken of er voor elk stukje een begin en eindborder
     //gevonden wordt op de Y AS zoja kijk of er een stukje blok staat (>0)
     //-> temp waarde
     vertendborderfound := false;
     vertstartborderfound := false;
     if y < rows -1 then
      for tellery := y+1 to rows -1 do
       if playfield[0,x,tellery] < 0 then vertendborderfound := true;
     if y > 0 then
      for tellery := y-1 downto 0 do
       if playfield[0,x,tellery] <0 then vertstartborderfound := true;
     if vertStartBorderfound and vertendborderfound then temp := temp and (playfield[0,x,y] > 0);
    end;
   end;
  end;
 end;
 result := temp;
end;

Procedure DrawPanel;
var
 Text : PSDL_Surface;
 Color : TSDL_Color;
 DstRect : TSDL_Rect;
begin
 Color.r := 255;
 Color.g := 255;
 Color.b := 255;
 Text := TTF_RenderText_Solid(font,Pchar('Room Number: ' + inttostr(level)),Color);
 DstRect.x := Screen.w div 4 - Text.w div 2;
 Dstrect.y := 0;
 DstRect.w := Text.w;
 DstRect.h := Text.h;
 SDL_BlitSurface(Text,nil,Screen,@DstRect);
 SDL_FreeSurface(Text);
 Text := TTF_RenderText_Solid(font,pchar('Time: ' + TimeToStr(EndTime - StartTime)),Color);
 DstRect.x := 3* (Screen.w div 4) - Text.w Div 2 ;
 DstRect.y := 0;
 Dstrect.w := Text.w;
 DstRect.h := Text.h;
 SDL_BlitSurface(Text,nil,Screen,@DstRect);
 SDL_FreeSurface(Text);
end;

procedure game;
Var
 PlayFieldX,PlayFieldY,Blocknr : integer;
 Keys : PKeyStateArr;
 Event : TSDL_Event;
 movedelay : integer;
begin
 case random(2) of
  0:if GlobalSoundEnabled and musicenabled then Mix_PlayMusic(music[MUS_Game1],-1);
  1:if GlobalSoundEnabled and musicenabled then Mix_PlayMusic(music[MUS_Game2],-1);
 end;
 movedelay := 0;
 HandCursor := Thand.create;
 HandCursor.X := XoffSetGame + 10 * BlockWidth;
 HandCursor.Y := YoffSetGame + 8 * BlockHeight;
 loadlevel;
 StartTime := now;
 While GameState = GSGame do
 begin
  While SDL_PollEvent(@event) > 0 do
  begin
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_ESCAPE) then
      begin
       GameState := GSTitleScreen;
       Mix_haltMusic;
      end;
   if (event.type_ = SDL_QUITEV) then
    GameState := GSQuit;
   if (event.type_ = SDL_KEYDOWN) then
   case event.key.keysym.sym of
    SDLK_SPACE:
    begin
     if not BlockActive then
     begin
      PlayFieldX := (HandCursor.X - XoffSetGame) div BlockWidth;
      PlayfieldY := (HandCursor.Y - YoffSetGame) div BlockHeight;
      Blocknr := PlayField[0,PlayFieldX,PlayfieldY];
      If Blocknr > 0 then
      begin
       if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_PickupBlock],0);
       BlockActive := true;
       HandCursor.hidden := true;
       MakeBlockActive(playfieldx,playfieldy,blocknr);
      end;
     end
     else
     begin
      if MakeBlockunActive then
      begin
       if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_DropBlock],0);
       BlockActive := False;
       if IsStageClear then
       begin
        GameState := GSStageClear;
        if GlobalSoundEnabled and soundenabled then channel := mix_playchannel(-1,sounds[SND_StageEnd],0);
       end
       else Handcursor.Hidden := False;
      end
      else
      if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_error],0);
     end;
    end;
    SDLK_R:
     if blockactive then rotateblock;
    SDLK_H:
     if blockactive then flipblock(True);
    SDLK_V:
     if blockactive then flipblock(false);
    SDLK_RETURN:
    begin
     loadlevel;
     BlockActive := false;
     HandCursor.Hidden := false;
    end;
   end;
  end;
  inc (movedelay);
  if movedelay = 4 then
  begin
   Keys := PKeyStateArr(SDL_GetKeyState(nil));
   if keys[SDLK_RIGHT] = 1 then If blockactive then MoveBlockRight;
   if keys[SDLK_LEFT] = 1 then If blockactive then MoveBlockLEft;
   if keys[SDLK_UP] = 1 then if blockactive then moveblockup;
   if keys[SDLK_DOWN] = 1 then if blockactive then moveblockdown;
   movedelay := 0;
  end;

  EndTime := Now;
  SDL_BlitSurface(RoomBackground,nil,Screen,nil);
  DrawPanel;
  DrawPlayField;
  handcursor.Move;
  Handcursor.Draw;
  SDL_Flip(Screen);

  Sdl_Delay(waitforframe);
 end;
 HandCursor.Free;
end;
// End of Game Stuff ---------------------------------------------------

//Stage Clear stuff ----------------------------------------------------
Procedure StageClear;
var
 event : TSDL_Event;
 DstRect : TSDL_Rect;
 KaderVisible : Boolean;
begin
 kaderVisible := true;
 While GameState = GSStageClear do
 begin
  While SDL_PollEvent(@event) > 0 do
  begin
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_ESCAPE) then
      begin
       Mix_HaltChannel(0);
       Mix_HaltChannel(1);
       Mix_haltMusic;
       GameState := GSTitleScreen;
      end;
   if (event.type_ = SDL_QUITEV) then
    GameState := GSQuit;
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_SPACE) then
    kadervisible := not kadervisible;
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_RETURN) then
    begin
     Mix_HaltChannel(0);
     Mix_HaltChannel(1);
     Mix_HaltMusic;
     GameState := GSOldmanSpeaking;
    end;
  end;
  DstRect.x := XoffSetGame;
  Dstrect.y := YoffSetGame + 150;
  DstRect.w := StageClearKader.w;
  Dstrect.h := StageClearKader.h;
  SDL_BlitSurface(RoomBackground,nil,Screen,nil);
  DrawPanel;
  DrawPlayField;
  If KaderVisible then SDL_BlitSurface(StageClearKader,nil,Screen,@dstrect);
  SDL_Flip(Screen);
 end;
end;
//End of Stage Clear Stuff ---------------------------------------------

//Next Stage Scene Stuff
{ TPlayer --------------------------------------------------------------}
constructor TPlayer.Create(Xin,Yin,MinXin,MaxXin : integer);
begin
 Image := IMG_Load(Pchar(GetAppPath + 'Graphics\' +'Ryf-player.bmp'));
 Shadow := IMG_Load(Pchar(GetAppPath + 'Graphics\' +'Ryf-Shadow.bmp'));
 SDL_SetColorKey(Image,SDL_SRCCOLORKEY OR SDL_RLEACCEL OR SDL_HWACCEL,SDL_MapRGB(Image.format,255,0,255));
 SDL_SetColorKey(Shadow,SDL_SRCCOLORKEY OR SDL_RLEACCEL OR SDL_HWACCEL,SDL_MapRGB(Shadow.format,255,0,255));
 SDL_SetAlpha(Shadow,SDL_SRCALPHA or SDL_RLEACCEL,128);
 Y := Yin;
 x := Xin;
 Width := 47;
 Height := 57;
 AnimCounter := 0;
 Delay := 0;
 animphase := 0;
 Maxx := Maxxin;
 Minx := MinXin;
 State := Waiting;
end;

procedure TPlayer.Draw;
var
dstRect,SrcRect : SDL_Rect;
begin
 DstRect.x := X + (width div 2) - (shadow.w div 2);
 DstRect.y := Y + Height - Shadow.h div 2;
 DstRect.w := Shadow.w;
 DstRect.h := Shadow.h;
 SDL_BlitSurface(Shadow,nil,Screen,@DstRect);

 dstRect.x := x;
 dstRect.y := Y;
 DstRect.w := Width;
 DstRect.h := Height;
 SrcRect.x := Animphase * width;
 SrcRect.y := 0;
 SrcRect.w := Width;
 SrcRect.h := Height;
 SDL_BlitSurface(Image,@srcRect,Screen,@DstRect);
end;

destructor TPlayer.Free;
begin
 SDL_FreeSurface(Shadow);
 SDL_FreeSurface(Image);
end;

procedure TPlayer.move;
Const
 AnimLeft : array[0..5] of integer = (12,11,10,9,8,7);
 AnimRight : Array[0..5] of integer = (1,2,3,4,5,6);
 AnimEnterBuilding : Array[0..3] of integer = (15,16,17,18);
var
 Keys : PKeyStateArr;
begin
 If (State = walking) or (State=Waiting) then
 begin
  Keys := PKeyStateArr(SDL_GetKeyState(nil));

  if keys[SDLK_LEFT] = 1 then
  begin
   If X - 2 >= Minx then
   begin
    X := X -2;
    Animphase := AnimLeft[animcounter];
    State := Walking;
   end
   else
    State := Waiting;
  end
  else
  if keys[SDLK_RIGHT] = 1 then
  begin
   if X + 2 <= MaxX then
   begin
    X := X + 2;
    Animphase := AnimRight[AnimCounter];
    State := Walking;
   end
   else
    State := Waiting;
  end
  else
  State := Waiting;
 end;

 If State = Walking then
 begin
  Inc(Delay);
  If Delay = 10 then
  begin
   Inc(Animcounter);
   Delay := 0;
  end;
  if animcounter > 5 then Animcounter := 0;
 end;

 If State = EnterBuilding then
 begin
  inc(Delay);
  If Delay >= 8 then
  begin
   inc(Animcounter);
   Delay := 0;
   Y := Y - 2;
  end;
  If Animcounter > 3 then
  begin
   animcounter := 0;
   If Y <= 324 then State := EnteredBuilding;
  end;

  Animphase := AnimEnterBuilding[animcounter];
 end;

 If State = Waiting then
 begin
  If (AnimPhase <> 0) and (AnimPhase <> 13) then
   If animphase = 14 then
    animphase := 0
   else
   if (Animphase < 7) then
    animphase := 0
   else
    animphase := 13;
 end;

 If State = Lookingup then
  animphase := 14;
end;

{ TSpaceShip }
constructor TSpaceShip.Create;
begin
 Image := IMG_Load(Pchar(GetAppPath + 'Graphics\' + 'SpaceShip.bmp'));
 SDL_SetColorKey(Image,SDL_SRCCOLORKEY OR SDL_RLEACCEL OR SDL_HWACCEL,SDL_MapRGB(Image.format,255,0,255));
 X := 0 - Image.w;
 Y := 55;
end;

procedure TSpaceShip.Draw;
var
 SrcRect,DstRect : TSDL_Rect;
begin
 If (X < 0) and (X >= -Image.w) then
 begin
  SrcRect.x := abs(X);
  SrcRect.y := 0;
  SrcRect.w := X  + Image.w;
  SrcRect.h := Image.h;
  DstRect.x := X;
  DstRect.y := Y;
  DstRect.w := X + Image.w;
  DstRect.h := Image.h;
  SDL_BlitSurface(image,@srcrect,screen,@dstrect);
 end
 Else
  if (X >= 0) and (X <= 639 - Image.w) then
  begin
   SrcRect.x := 0;
   SrcRect.y := 0;
   SrcRect.w := Image.w;
   SrcRect.h := Image.h;
   DstRect.x := X;
   DstRect.y := Y;
   DstRect.w := Image.w;
   DstRect.h := Image.h;
   SDL_BlitSurface(Image,@SrcRect,Screen,@DstRect);
  end
  else
   if( X > 639 - Image.w) and (X < 640 ) then
   begin
    SrcRect.x := 0;
    SrcRect.y := 0;
    SrcRect.w := 639 - X;
    SrcRect.h := Image.h;
    DstRect.x := X;
    DstRect.y := Y;
    DstRect.w := 639-X;
    DstRect.h := Image.h;
    SDL_BlitSurface(Image,@SrcRect,Screen,@DstRect);
   end;
end;

destructor TSpaceShip.Free;
begin
 SDL_FreeSurface(Image);
end;

procedure TSpaceShip.Move;
begin
 if X < 640 then X := X + 3;
end;

{TCloud -----------------------------------------------------------------}
constructor TCloud.Create(Xin, Yin: integer; Xiin: real;Style:TCloudStyle);
begin
 if Style = Big then
  Image := IMG_Load(pchar(getapppath + 'Graphics\' + 'Ryf-Cloud.bmp'))
 else
  Image := IMG_Load(pchar(getapppath + 'Graphics\' + 'Ryf-SmallCloud.bmp'));
 SDL_SetColorKey(Image,SDL_SRCCOLORKEY or SDL_RLEACCEL OR SDL_HWACCEL,SDL_MapRGB(Image.format,255,0,255));
 Width := Image.w;
 Height := Image.h;
 X := Xin;
 Y := Yin;
 Xi := Xiin;
end;

procedure TCloud.Draw;
Var
SrcRect, DstRect : TSDL_Rect;
begin
 If (X < 0) and (X >= -Image.w) then
 begin
  SrcRect.x := abs(trunc(X));
  SrcRect.y := 0;
  SrcRect.w := trunc(X)  + Image.w;
  SrcRect.h := Image.h;
  DstRect.x := trunc(X);
  DstRect.y := Y;
  DstRect.w := trunc(X) + Image.w;
  DstRect.h := Image.h;
  SDL_BlitSurface(image,@srcrect,screen,@dstrect);
 end
 Else
  if (X >= 0) and (X <= 639 - Image.w) then
  begin
   SrcRect.x := 0;
   SrcRect.y := 0;
   SrcRect.w := Image.w;
   SrcRect.h := Image.h;
   DstRect.x := trunc(X);
   DstRect.y := Y;
   DstRect.w := Image.w;
   DstRect.h := Image.h;
   SDL_BlitSurface(Image,@SrcRect,Screen,@DstRect);
  end
  else
   if( X > 639 - Image.w) and (X < 640 ) then
   begin
    SrcRect.x := 0;
    SrcRect.y := 0;
    SrcRect.w := 639 - trunc(X);
    SrcRect.h := Image.h;
    DstRect.x := trunc(X);
    DstRect.y := Y;
    DstRect.w := 639-trunc(X);
    DstRect.h := Image.h;
    SDL_BlitSurface(Image,@SrcRect,Screen,@DstRect);
   end;
end;

destructor TCloud.Free;
begin
 SDL_FreeSurface(Image);
end;

procedure TCloud.Move;
begin
 If (X > -Width) and (X < 640) then X := X + Xi
 else
  if X <= -Width then X := 639 else X := -Width+1;
end;

{ TFairy }
constructor TFairy.Create(Xin,Yin,AnimDelayIn:Integer);
begin
 Image := IMG_Load(pchar(GetappPAth + 'Graphics\' + 'Ryf-fairy.bmp'));
 SDL_SetColorKey(image,SDL_SRCCOLORKEY or SDL_RLEACCEL or SDL_HWACCEL,SDL_MapRGB(Image.format,255,0,255));
 x := Xin;
 y := Yin;
 Width := 36;
 Height := 44;
 Animphase := 0;
 Delay := 0;
 hidden := false;
 AnimDelay := AnimDelayIn;
end;

procedure TFairy.Draw;
Var
 SrcRect,DstRect : TSDL_Rect;
begin
 if not hidden then
 begin
  SrcRect.x := Animphase * Width;
  SrcRect.y := 0;
  SrcRect.w := Width;
  SrcRect.h := Height;
  DstRect.x := x;
  DstRect.y := y;
  DstRect.w := width;
  DstRect.h := Height;
  SDL_BlitSurface(image,@srcrect,Screen,@dstrect);
  Inc(Delay);
  If Delay >= AnimDelay then
  begin
   inc(animphase);
   delay := 0;
  end;
  if animphase = 2 then animphase := 0;
 end;
end;

destructor TFairy.Free;
begin
 SDL_FreeSurface(image);
end;

{ TStageBlock }
constructor TStageBlock.Create(Blocknr: integer);
begin
 Image := IMG_Load(pchar(GetAppPath + 'Graphics\' + 'StageBlock' + inttostr(blocknr) + '.bmp'));
 SDL_SetColorKey(image,SDL_SRCCOLORKEY or SDL_RLEACCEL or SDL_HWACCEL,SDL_MapRGB(Image.format,255,0,255));
 Hidden := False;
 Yi := 3;
 X := Screen.w div 2 - image.w div 2;
 Y := -Image.h;
 Width := Image.w;
 Height := Image.h;
end;

procedure TStageBlock.Draw;
Var
 dstRect : TSDL_Rect;
begin
 if not hidden then
 begin
  dstRect.x := x;
  dstRect.y := y;
  DstRect.w := Width;
  DstRect.h := Height;
  SDL_BlitSurface(image,nil,screen,@dstrect);
 end;
end;

destructor TStageBlock.Free;
begin
 SDL_FreeSurface(Image);
end;

procedure TStageBlock.Move;
begin
 if not hidden then
 begin
  Y := Y + Yi;
 end;
end;

Procedure NextStageLevel0;
var
 player : Tplayer;
 event : TSDL_Event;
 Cloud1,Cloud2,Cloud3,Cloud4 : TCloud;
 NextStageBackGround,Text : PSDL_Surface;
 DstRect : TSDL_Rect;
 Color : TSDL_Color;
begin
 NextStageBackGround := IMG_Load(pchar(GetAppPath + 'Graphics\' +'BetweenStagelevel1.bmp'));
 if GlobalSoundEnabled and musicenabled then Mix_PlayMusic(music[MUS_Stage],-1);
 player := Tplayer.create(450,335,450,536);
 Cloud1 := TCloud.Create(639-120,30,-0.40,big);
 Cloud2 := TCloud.Create(639-270,90,-0.25,Small);
 Cloud3 := TCloud.Create(639-370,15,-0.40,Big);
 Cloud4 := TCloud.Create(100,100,-0.25,Small);
 Color.r := 0;
 Color.g := 0;
 Color.b := 0;
 Text := TTF_RenderText_Solid(font,pchar(inttostr(level +1)),color);
 Dstrect.x :=532+((583-532) div 2 - text.w div 2);
 Dstrect.y :=210;
 DstRect.w := text.w;
 DstRect.h := Text.h;
 While GameState = GSNextStage do
 begin
  While SDL_PollEvent(@event) > 0 do
  begin
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_ESCAPE) then
    gameState := GSTitleScreen;
   if (event.type_ = SDL_QUITEV) then
    GameState := GSQuit;

   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_RETURN) then
      begin
       if Player.X > 530 then
       begin
        Inc(Level);
        Player.State := EnterBuilding;
       end;
      end;
  end;
  SDL_BlitSurface(NextStageBackGround,nil,screen,nil);
  SDL_BlitSurface(Text,nil,screen,@dstrect);
  Cloud1.Move();
  Cloud1.Draw;
  Cloud2.Move;
  Cloud2.Draw;
  Cloud3.Move;
  Cloud3.draw;
  Cloud4.Move;
  Cloud4.Draw;
  Player.move;
  Player.Draw;
  SDL_Flip(Screen);
  SDL_Delay(waitforframe);
  If player.State = EnteredBuilding then GameState := GSGame;
 end;
 Player.free;
 Cloud1.Free;
 Cloud2.free;
 Cloud3.free;
 Cloud4.free;
 Mix_HaltMusic;
 SDL_FreeSurface(Text);
 SDL_FreeSurface(NextStageBackGround);
end;


Procedure NextStageLevel1to35;
var
 player : Tplayer;
 SpaceShip : TspaceShip;
 event : TSDL_Event;
 BridgeShown,BridgeDrawing : Boolean;
 BridgeDrawnWidth : Integer;
 PrevlevelDstRect,NextLevelDstRect,BridgeSrcRect,BridgeDstRect,TextDstRect :TSDL_Rect;
 Color : TSDL_Color;
 Cloud1,Cloud2,Cloud3,Cloud4 : TCloud;
 NextStageBackGround,Text,prevlevel,nextlevel : PSDL_Surface;
 Fairy : TFairy;
 StageBlock : TStageBlock;
begin
 NextStageBackGround := IMG_Load(pchar(GetAppPath + 'Graphics\' +'BetweenStage.bmp'));
 if GlobalSoundEnabled and musicenabled then Mix_PlayMusic(music[MUS_stage],-1);
 BridgeShown := False;
 BridgeDrawing := False;
 BridgeDrawnWidth := 0;
 player := Tplayer.create(60,335,60,536);
 SpaceShip := TSpaceShip.Create;
 Cloud1 := TCloud.Create(639-120,30,-0.40,big);
 Cloud2 := TCloud.Create(639-270,90,-0.25,Small);
 Cloud3 := TCloud.Create(639-370,15,-0.40,Big);
 Cloud4 := TCloud.Create(100,100,-0.25,Small);
 Fairy := TFairy.Create(345,319,15);
 Case Level of
  1: StageBlock := TStageBlock.Create(1);
  2: StageBlock := TStageBlock.Create(2);
  3: StageBlock := TStageBlock.Create(3);
  4: StageBlock := TStageBlock.Create(4);
  5: StageBlock := TStageBlock.Create(5);
  6: StageBlock := TStageBlock.Create(6);
  8: StageBlock := TStageBlock.Create(7);
  9: StageBlock := TStageBlock.Create(8);
  11:StageBlock := TStageBlock.Create(9);
  35:StageBlock := TStageBlock.Create(10);
  else StageBlock := TStageBlock.Create(1); // just to initialize it's never shown on screen since there's no fairy on those stages
 end;
 Color.r := 75;
 Color.g := 250;
 Color.b := 250;
 text := TTF_RenderText_Solid(font,pchar(LevelPassWords[level+1]),color);
 TextDstRect.x := Screen.w div 2 - Text.w div 2;
 TextDstRect.y := 50;
 TextDstRect.w := text.w;
 TextDstRect.h := text.h;
 Color.r := 0;
 Color.g := 0;
 Color.b := 0;
 NextLevel := TTF_RenderText_Solid(font,pchar(inttostr(level+1)),color);
 nextlevelDstrect.x :=532+((583-532) div 2 - NextLevel.w div 2);
 nextlevelDstrect.y :=210;
 nextlevelDstRect.w := NextLevel.w;
 nextlevelDstRect.h := NextLevel.h;
 PrevLevel := TTF_RenderText_Solid(font,pchar(inttostr(level)),color);
 PrevLevelDstRect.x := 57 + ((107-57) div 2 - Prevlevel.w div 2);
 PrevlevelDstRect.y := 210;
 Prevleveldstrect.w := PrevLevel.w;
 Prevleveldstrect.h := PrevLevel.h;
 While GameState = GSNextStage do
 begin
  While SDL_PollEvent(@event) > 0 do
  begin
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_ESCAPE) then
    GameState := GSTitleScreen;
   if (event.type_ = SDL_QUITEV) then
    GameState := GSQuit;

   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_RETURN) then
      begin
       if Player.X > 530 then
       begin
        inc(level);
        Player.State := EnterBuilding;
       end;
       if Player.X < 65 then
       begin
        Player.State := EnterBuilding;
       end;
      end;
  end;
  SDL_BlitSurface(NextStageBackGround,nil,screen,nil);
  Cloud1.Move;
  Cloud1.Draw;
  Cloud2.Move;
  Cloud2.Draw;
  Cloud3.Move;
  Cloud3.draw;
  Cloud4.Move;
  Cloud4.Draw;
  if not BridgeShown then
  begin
   if not BridgeDrawing then
   begin
    If Player.X > 185 then
    begin
     BridgeDrawing := true;
     if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Bridge],0);
    end
   end
   else
   begin
    BridgeSrcRect.x := 0;
    BridgeSrcRect.y := 0;
    BridgeSrcRect.w := BridgeDrawnWidth;
    BridgeSrcRect.h := Bridge.h;
    BridgeDstRect.x := 223;
    BridgeDstRect.Y := 377;
    BridgeDstRect.W := BridgeDrawnWidth;
    BridgeDstRect.H := Bridge.H;
    BridgeDrawnWidth := BridgeDrawnWidth + 5;
    if BridgeDrawnWidth >= Bridge.W then
     begin
     BridgeDrawing := false;
     BridgeShown := True;
     BridgeSrcRect.w := Bridge.w;
     BridgeDstrect.w := Bridge.w;
    end;
     SDL_BlitSurface(Bridge,@Bridgesrcrect,Screen,@BridgeDstRect);
   end;
  end
  else
  SDL_BlitSurface(Bridge,nil,Screen,@BridgeDstRect);
  Player.move;
  Player.Draw;

  // als speler fairy raakt stop zijn movement en start met de nieuwe block te tekenen
  If level in [1,2,3,4,5,6,8,9,11,35] then
  begin
    Fairy.Draw;
    If (Player.state <> Lookingup) and (not fairy.Hidden) and (player.X + player.Width >= Fairy.x) then
    begin
     if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Elf],0);
     Fairy.Hidden := true;
     Player.State := Lookingup;
    end;
    If Player.state = lookingup then
    begin
     StageBlock.Draw;
     StageBlock.Move;
     if StageBlock.Y + StageBlock.Height >= Player.Y then
     begin
      Player.State := Waiting;
      StageBlock.Hidden := true;
     end;
    end;
  end;
  // teken passwoord onder spaceship
  SpaceShip.Move;
  If (SpaceShip.X > Screen.w div 2 - Text.w div 2) then
  begin
   Sdl_BlitSurface(Text,nil,Screen,@TextDstRect);
  end;
  SpaceShip.Draw;
  SDL_BlitSurface(Prevlevel,nil,Screen,@PrevleveldstRect);
  SDL_BlitSurface(NextLevel,nil,Screen,@NextLevelDstRect);
  SDL_Flip(Screen);
  SDL_Delay(waitforframe);
  If player.State = EnteredBuilding then GameState := GSGame;
 end;
 Mix_HaltMusic();
 Player.free;
 SpaceShip.Free;
 Cloud1.Free;
 Cloud2.free;
 Cloud3.free;
 Cloud4.free;
 Fairy.Free;
 StageBlock.Free;
 SDL_FreeSurface(prevlevel);
 SDL_FreeSurface(nextlevel);
 SDL_FreeSurface(text);
 SDL_FreeSurface(NextStageBackGround);
end;

Procedure NextStage;
begin
 Case Level of
  0: NextStageLevel0;
  1..35: NextStageLevel1to35;
 end;
end;
//End Of Next Stage Scene Stuff

//Begin of Password Entry------------------------------------------------;
{ TPasswordSelector------------------------------------------------------}
constructor TPasswordSelector.Create;
begin
 Image := img_load(pchar(getapppath + 'Graphics\' + 'select.bmp'));
 SDL_SetColorKey(Image,SDL_SRCCOLORKEY,SDL_MapRGB(Image.format,255,0,255));
 X := 0;
 Y := 0;
end;

procedure TPasswordSelector.Draw;
var
 DstRect : TSDL_Rect;
begin
 DstRect.x := XOffsetpassword + X * 70;
 DstRect.y := YOffSetPassword + y * 70;
 DstRect.w := Image.w;
 DstRect.h := Image.h;
 SDL_BlitSurface(Image,nil,Screen,@DstRect);
end;

destructor TPasswordSelector.Free;
begin
 SDL_FreeSurface(Image);
end;

procedure TPasswordSelector.movedown;
begin
 if (Y < LetterRows -2) then
 begin
  Y := Y + 1;
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Menu],0);
 end
 else
 If (Y = LetterRows -2) and (X < LetterCols -2) then
 begin
  Y := Y + 1;
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Menu],0);
 end;
end;

procedure TPasswordSelector.moveleft;
begin
 if X > 0 then
 begin
  X := X -1;
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Menu],0);
 end;
end;

procedure TPasswordSelector.moveright;
begin
 If Y < LetterRows - 1 then
  if X < LetterCols - 1 then
  begin
   X := X +1;
   if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Menu],0);
  end;
 if Y = LetterRows - 1 then
  if X < Lettercols - 3 then
  begin
   X := X + 1;
   if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Menu],0);
  end;
end;

procedure TPasswordSelector.moveup;
begin
 if Y > 0 then
 begin
  Y := Y - 1;
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Menu],0);
 end;
end;

Function GetLeveL(Password : string) : integer;
var
 teller : integer;
begin
 Result := -1;
 for teller := 1 to 36 do
 begin
  if Password = LevelPasswords[teller] then
  begin
   result := teller;
   exit;
  end;
 end;
end;

Procedure PasswordEntry;
var
 Event : TSDL_Event;
 Background,text : PSDL_Surface;
 letterX,LetterY : integer;
 Color : TSDL_Color;
 DstRect : TSDL_Rect;
 Selector : TPasswordSelector;
 Password : String;
begin
 Background := IMG_Load(pchar(getapppath + 'Graphics\' + 'paper.bmp'));
 Color.r := 0;
 Color.g := 0;
 Color.b := 0;
 Selector := TPasswordSelector.Create;
 Password := '';
 WHile GameState = GSPasswordEntry do
 begin
  While SDL_PollEvent(@event) > 0 do
  begin
   if event.type_ = SDL_QUITEV then
    GameState := GSQuit;
   if event.type_ = SDL_KEYDOWN then
    case event.key.keysym.sym of
     SDLK_ESCAPE: GameState := GSTitleScreen;
     SDLK_RETURN,SDLK_SPACE:
     begin
      Password := Password + Letters[Selector.y,Selector.x];
      if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Select],0);
     end;
     SDLK_UP: selector.moveup;
     SDLK_DOWN: selector.movedown;
     SDLK_LEFT: Selector.moveleft;
     SDLK_RIGHT: Selector.moveright;
    end;
  end;
  SDL_BlitSurface(Background,nil,screen,nil);
  if length(Password) > 0 then
  begin
   Text := TTF_RenderText_Solid(font,pchar(Password),Color);
   DstRect.x := Screen.w div 2 - Text.w div 2;
   DstRect.y := 75;
   DstRect.w := Text.w;
   DstRect.h := Text.h;
   SDL_BlitSurface(text,nil,Screen,@DstRect);
   SDL_FreeSurface(Text);
  end;
  For lettery := 0 to letterrows -1 do
   for letterx := 0 to lettercols -1 do
   begin
    If letters[lettery,letterx] <> '0' then
    begin
     Text := TTF_RenderText_Solid(font,pchar(letters[lettery,letterx]),Color);
     DstRect.x := XOffsetpassword + Letterx * 70;
     DstRect.y := YOffsetpassword + LetterY * 70;
     DstRect.w := Text.w;
     DstRect.h := Text.h;
     SDL_BlitSurface(Text,nil,Screen,@DstRect);
     Sdl_freeSurface(text);
    end;
   end;
  Selector.draw;
  SDL_Flip(Screen);
  SDl_Delay(waitforframe);
  If Length(Password) = 4 then
  begin
   SDL_Delay(250);
   if getlevel(Password) = -1 then
   begin
    password := '';
    if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_error],0);
   end
   else
   If GetLevel(Password) = 1 then
   begin
    GameState := GSStageSelect;
   end
   else
   begin
    Level := getlevel(Password) -1;
    GameState := GSoldmanSpeaking;
    Mix_HaltMusic;
   end;
  end;
 end;
 Selector.free;
 SDL_FreeSurface(Background);
end;
//End of Password Entry -------------------------------------------------

//Begin of TitleScreen --------------------------------------------------
{ TTitleScreenSelector --------------------------------------------------}
constructor TTitleScreenSelector.Create;
begin
 image := IMG_Load(pchar(getapppath + 'Graphics\' + 'TitleSelector.bmp'));
 SDL_SetColorKey(Image,SDL_SRCCOLORKEY or SDL_RLEACCEL or SDL_HWACCEL,SDL_MapRGB(Image.format,255,0,255));
 Selection := 1;
end;

procedure TTitleScreenSelector.Draw;
var
 DstRect : TSDL_Rect;
begin
 Case Selection of
  1: DstRect.y := 132;
  2: DstRect.y := 200;
  3: DstRect.y := 273;
  4: DstRect.y := 351;
 end;
 Dstrect.x := 143;
 DstRect.w := image.w;
 DstRect.h := Image.h;
 SDL_BlitSurface(image,nil,screen,@DstRect);
end;

destructor TTitleScreenSelector.Free;
begin
 SDL_FreeSurface(Image);
end;

procedure TTitleScreenSelector.MoveDown;
begin
 if Selection < 4 then
 begin
  inc(Selection);
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Menu],0);
 end;
end;

procedure TTitleScreenSelector.Moveup;
begin
 if Selection > 1 then
 begin
  Dec(Selection);
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Menu],0);
 end;
end;

Procedure TitleScreen;
var
 Event : TSDL_Event;
 Background : PSDL_Surface;
 Selector : TTitleScreenSelector;
begin
 Background := IMG_Load(pchar(GetappPath + 'Graphics\' + 'Title.bmp'));
 Selector := TTitleScreenSelector.Create;
 if GlobalSoundEnabled and musicenabled then
  if Mix_Playingmusic() = 0 then Mix_PlayMusic(music[MUS_Title],-1);
 while GameState = GSTitleScreen do
 begin
  While SDL_Pollevent(@event) > 0 do
  begin
   If (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_ESCAPE) or
      (Event.type_ = SDL_QUITEV) then
      GameState := GSQuit;
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_UP) then
       selector.Moveup;
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_DOWN) then
       selector.MoveDown;
   if (event.type_ = SDL_KEYDOWN) and
      ((Event.key.keysym.sym = SDLK_RETURN) or
      (Event.key.keysym.sym = SDLK_SPACE)) then
      begin
       if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Select],0);
       Case Selector.Selection of
        1:
        begin
         Level := 0;
         GameState := GSOldManSpeaking;
        end;
        2: GameState := GSPasswordEntry;
        3: GameState := GSOptions;
        4: GameState := GSCredits;
       end;
      end;
  end;
  SDL_BlitSurface(Background,nil,Screen,nil);
  Selector.Draw;
  SDL_Flip(screen);
  Sdl_Delay(waitforframe);
 end;
 Selector.Free;
 SDL_FreeSurface(Background);
end;
//End of TitleScreen ----------------------------------------------------

//Begin of StageSelect --------------------------------------------------;
{TStageSelectSelector}
constructor TStageSelectSelector.Create;
begin
 Image := IMG_Load(pchar(getapppath + 'Graphics\' + 'Select.bmp'));
 SDL_SetColorKey(image,SDL_SRCCOLORKEY or SDL_RLEACCEL or SDL_HWACCEL,SDL_MapRGB(Image.format,255,0,255));
 Selection := 0;
 X := 0;
 Y := 0;
end;

procedure TStageSelectSelector.Draw;
var
 DstRect : TSDL_Rect;
begin
 DstRect.x := XOffsetStageSelect+ X * 165 + 85; //+85 om selector achter text te krijgen text = 105 pxls width max
 DstRect.y := YOffsetStageSelect + Y * 25;
 DstRect.w := Image.w;
 DstRect.h := Image.h;
 SDL_BlitSurface(Image,nil,screen,@dstrect);
end;

destructor TStageSelectSelector.free;
begin
 SDL_FreeSurface(image);
end;

procedure TStageSelectSelector.movedown;
begin
 if Y < 11 then
 begin
  Y := Y + 1;
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_MEnu],0);
 end;
 Selection := X + Y*3;
end;

procedure TStageSelectSelector.moveleft;
begin
 if X > 0 then
 begin
  X := X - 1;
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_MEnu],0);
 end ;
 Selection := x + y*3;
end;

procedure TStageSelectSelector.moveright;
begin
 if X < 2 Then
 begin
  x := x + 1;
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_MEnu],0);
 end ;
 Selection := x + y*3;
end;

procedure TStageSelectSelector.moveup;
begin
 if Y > 0 then
 begin
  Y := Y - 1;
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_MEnu],0);
 end;
 Selection := X + Y * 3;
end;

procedure StageSelect;
var
 event: TSDL_Event;
 Background,Text : PSDL_Surface;
 teller : integer;
 color : TSDL_Color;
 DstRect : TSDL_Rect;
 Selector : TStageSelectSelector;
 begin
 Background := IMG_Load(pchar(getapppath + 'Graphics\' + 'paper.bmp'));
 Selector := TStageSelectSelector.create;
 color.r := 0;
 Color.b := 0;
 Color.g := 0;
 While GameState = GSStageSelect do
 begin
  While SDL_Pollevent(@event) > 0 do
  begin
   if event.type_ = SDL_QUITEV then
      GameState := GSQuit;
   if (event.type_ = SDL_KEYDOWN) then
    case event.key.keysym.sym of
     SDLK_ESCAPE: GameState := GSTitleScreen;
     SDLK_RETURN,SDLK_SPACE:
     begin
      if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Select],0);
      Level := Selector.Selection;
      GameState := GSoldmanSpeaking;
      Mix_HaltMusic;
     end;
     SDLK_LEFT: selector.moveleft;
     SDLK_RIGHT: Selector.moveright;
     SDLK_UP: Selector.moveup;
     SDLK_Down:Selector.movedown;
    end;
  end;
  SDL_BlitSurface(Background,nil,screen,nil);
  Text := TTF_RenderText_Solid(font,'ROOM SELECT',color);
  DstRect.x := Screen.w div 2 - Text.w div 2;
  DstRect.y := 50;
  DstRect.w := Text.w;
  DstRect.h := Text.h;
  SDL_BlitSurface(text,nil,screen,@dstRect);
  SDL_FreeSurface(Text);
  For teller := 0 to 35 do
  begin
   Text := TTF_RenderText_Solid(font,pchar('Room ' + inttostr(teller+1)),Color);
   DstRect.x := XOffsetStageSelect + (Teller mod 3) * 165 ;
   DstRect.y := YOffsetStageSelect + (Teller Div 3) * 25 ;
   Dstrect.w := text.w;
   Dstrect.h := Text.h;
   SDL_BlitSurface(text,nil,screen,@dstrect);
   SDL_FreeSurface(Text);
  end;
  Selector.draw;
  SDL_Flip(screen);
  SDL_Delay(waitforframe);
 end;
 Selector.Free;
 SDL_FreeSurface(Background);
end;
//end of stageSelect

//begin of Intro
procedure intro;
Var
 Event : TSDL_Event;
 Pict1,Pict2,pict3,pict4,Pict5 : PSDL_Surface;
 Pictnr,x,y : integer;
 DstRect : TSDL_Rect;
begin
 Pictnr := 1;
 X := 640;
 Y := 480;
 Pict1 := SDL_DisplayFormat(Screen);
 Pict2 := IMG_Load(pchar(getapppath + 'graphics\' + 'sdlpowered.bmp'));
 Pict3 := IMG_Load(pchar(getapppath + 'graphics\' + 'Willemssoft.bmp'));
 Pict4 := IMG_Load(pchar(getapppath + 'graphics\' + 'title.bmp'));
 pict5 := SDL_DisplayFormat(Screen);
 SDL_SetColorKey(Pict5,SDL_SRCCOLORKEY or SDL_RLEACCEL or SDL_HWACCEL,SDL_MapRgb(Pict5.format,255,0,255));
 SDL_FillRect(Pict1,nil,SDL_MapRGB(Pict1.format,0,0,0));
 SDL_Delay(1500);
 While GameState = GSintro do
 begin
  While SDL_Pollevent(@event) > 0 do
  begin
   if (event.type_ = SDL_KEYDOWN) and
      ((event.key.keysym.sym = SDLK_ESCAPE) or
       (event.key.keysym.sym = SDLK_SPACE)) then
      GameState := GSTitleScreen;
   if event.type_ = SDL_QUITEV then
      GameState := GSQuit;
  end;
  Case pictnr of
   1: begin
       SDL_BlitSurface(Pict1,nil,Screen,nil);
       SDL_BlitSurface(Pict2,nil,Pict5,nil);
      end;
   2: Begin
       SDL_BlitSurface(Pict2,nil,Screen,nil);
       SDL_BlitSurface(Pict3,nil,pict5,nil);
      end;
   3: Begin
       SDL_BlitSurface(Pict3,nil,Screen,nil);
       SDL_BlitSurface(Pict4,nil,pict5,nil);
      end;
  end;
  DstRect.x := Screen.w div 2 - X div 2;
  DstRect.y := Screen.h div 2 - Y div 2;
  DstRect.w := x;
  DstRect.h := y;
  SDL_FillRect(Pict5,@dstrect,SDL_Maprgb(Pict5.format,255,0,255));
  SDL_BlitSurface(Pict5,nil,Screen,nil);
  SDL_Flip(Screen);
  X := x -15;
  If Y > 0 then Y := Y - 15
  else
  begin
   inc(Pictnr);
   if Pictnr = 4 then
    GameState := GSTitleScreen
   else
    SDL_Delay(2000);
   X := 640;
   Y := 480;
  end;
 end;
 SDL_FreeSurface(pict1);
 SDL_FreeSurface(pict2);
 SDL_FreeSurface(pict3);
 SDL_FreeSurface(pict4);
 SDL_FreeSurface(Pict5);
end;
//end of intro

//begin of oldmanspeaking
Procedure OldmanSpeaking;
Const
 // Chr(0) = End of page
 Tekst : Array[1..5] of String =
         ('WELCOME TO THE WORLD OF' +chr(13)+
          'PUZZLE LAND!'+ chr(13) +
          'IN LEVEL ONE WE''LL START WITH' +Chr(13) +
          'SIMPLE THREE-BLOCK' + chr(13) +
          'COMBINATIONS ...' + chr(0) +
          'WHEN YOU''VE MASTERED LEVEL' + chr(13)+
          'ONE, WE''LL ADD ANOTHER BLOCK.' + chr(13) +
          'HANG IN THERE!',
          'CONGRATULATIONS YOU MADE IT!' + chr(13)+
          'NOW WE''LL BOGGLE YOUR MIND,' + chr(13)+
          'THERE ARE 2339 DIFFRENT' + chr(13)+
          'CONFIGURATIONS IN THIS STAGE!' + chr(0) +
          'DON''T GIVE UP!' + chr(13) +
          'RELAX!',
          'HAH! THIS NEXT STAGE WILL' + CHR(13) +
          'SURPRISE YOU!' + CHR(13) +
          'YOU NOW HAVE 12 DIFFRENT' + chr(13)+
          'SHAPES TO WORK WITH ...' + CHR(0) +
          'SHOW ME HOW FAR YOU CAN' + CHR(13) +
          'GO DUDE!',
          'WELL, WELL, WELL.' + chr(13) +
          'YOU SEEM TO HAVE MADE IT ALL' +chr(13) +
          'THIS WAY! AS A TOKEN OF OUR' + chr(13) +
          'APPRECIATION FOR YOUR SKILL,...' + chr(0) +
          'HERE''S ANOTHER SQUARE BLOCK' + chr(13) +
          'TAKE THE SQUARE BLOCK, AND TRY' + chr(13) +
          'IT FOR THE LAST LEVEL!' + chr(0) +
          'IT LOOKS SIMPLE, BUT THERE ARE' + chr(13) +
          '16146 CONFIGURATIONS!' + chr(13)+ chr(13)+
          'HEY DUDE, YOU''RE ON IT AGAIN.',
          'CONGRATULATIONS YOU MADE IT!' + CHR(13)+
          'YOU''VE EARNED THE PASSWORD' + CHR(13)+
          'FOR THE LEVEL SELECT!' +chr(13) +
          'THE PASSWORD IS ''DAVY''');
var
 Event : TSDL_Event;
 Color : TSDL_Color;
 NrofChars,Pagenr,Teller,Tekstnr : Integer;
 List : TStringList;
 Line : String;
 Fairy : TFairy;
 Background : PSDL_Surface;
 textdelay : integer;
begin
 If level in [0,11,12,35,36] then
 begin
  if GlobalSoundEnabled and musicenabled then
   Mix_PlayMusic(music[MUS_Oldman],-1);
  textdelay := 0;
  Color.r := 255;
  Color.g := 255;
  Color.b := 255;
  line := '';
  NrOfChars := 0;
  Pagenr := 0;
  //What text to display based from the text array
  Case level of
   0: Tekstnr := 1;
   11: Tekstnr :=2;
   12: Tekstnr :=3;
   35: Tekstnr :=4;
   36: Tekstnr :=5;
   else Tekstnr := 1;// Just to get rid of the intialize warning
  end;
  Background := IMG_Load(Pchar(getapppath + 'Graphics\' + 'oldman.bmp'));
  Fairy := TFairy.Create(480,350,15);
  //Create a list of strings one string = one page nr, pages are seperated
  //with chr(0)
  List := TStringList.Create;
  if Tekstnr <> 0 then
  For teller := 1 to length(Tekst[Tekstnr]) do
  begin
   if Tekst[tekstnr][teller] = chr(0) then
   begin
    List.Add(line);
    line := '';
   end
   else
   Line := line + tekst[tekstnr][teller];
  end;
  if length(line) > 0 then list.Add(line);

  While GameState = GSOldManSpeaking do
  begin
   While SDL_PollEvent(@event) > 0 do
   begin
    if (event.type_ = SDL_QUITEV) then
     GameState := GSQuit;
    if (event.type_ = SDL_KEYDOWN) and
       (event.key.keysym.sym = SDLK_ESCAPE) then
     GameState := GSTitleScreen;
    if (event.type_ = SDL_KEYDOWN) and
       (event.key.keysym.sym = SDLK_SPACE) then
       //increase the pagenr if space is pressed
       begin
        if Pagenr < list.Count -1 then
        begin
         inc(pagenr);
         NrofChars := 0;
        end
        else
         if level < 36 then
          GameState := GSNextStage
         else
          GameState := GSCredits;
       end;
    if (event.type_ = SDL_KEYDOWN) and
       (event.key.keysym.sym = SDLK_RETURN) then
     if level < 36 then
      GameState := GSNextStage
     else
      GameState := GSCredits;
   end;
   SDL_BlitSurface(Background,nil,Screen,nil);
   Fairy.Draw;
   //increase the nr of letters to show
   inc(textdelay);
   if textdelay = 3 then
   begin
    if NrOfChars < length(list[Pagenr]) then inc(NrOfChars);
    textdelay := 0;
   end;

   //Write the actual page with the nr of visible chars
   WriteText(Screen,Font,list[Pagenr],NrofChars,100,100,10,Color);
   Sdl_Flip(Screen);
   SDL_Delay(waitforframe);
  end;
  SDL_FreeSurface(Background);
  Fairy.free;
  List.Free;
  Mix_HaltMusic;
 end
 else
  GameState := GSNextStage;
end;
//end of oldmanspeaking

//Start of Credits
Procedure credits;
Const
 Tekst = 'Puzzle Land is programmed by Willems Davy' + chr(13) +
         'using Borland Delphi 6 and JEDI-SDL.' + chr(13) +
         'Graphics are made using Paint Shop Pro 7.' + chr(13) +
         'A Big thanks goes out to Yann R. Fernandez' + chr(13) +
         'for creating the main hero, clouds, shadow' + chr(13) +
         'and fairy graphics.' + chr(13) +
         'Puzzle Land is a remake of Daedalian opus' + chr(13) +
         'for gameboy by Vic Tokai Inc. 1990' + chr(13) + chr(13) +
         'Willems Soft 2006';
var
 event : TSDL_Event;
 Background : PSDL_Surface;
 Color : TSDL_Color;
 NrofChars : Integer;
 textdelay : integer;
begin
 textdelay := 0;
 Color.r := 0;
 Color.b := 0;
 Color.g := 0;
 NrofChars := 0;
 Background := IMG_LOAD(pchar(getapppath + 'Graphics\' + 'paper.bmp'));
 While GameState = GSCredits do
 begin
  While SDL_PollEvent(@event) > 0 do
  begin
   if (event.type_ = SDL_QUITEV) then
    GameState := GSQuit;
   if (event.type_ = SDL_KEYDOWN) and
      ((event.key.keysym.sym = SDLK_ESCAPE) or
      (event.key.keysym.sym = SDLK_SPACE) or
      (event.key.keysym.sym = SDLK_RETURN)) then
    GameState := GSTitleScreen;
  end;
  inc(textdelay);
  if textdelay = 3 then
  begin
   if nrOfchars < Length(tekst) then Inc(NrofChars);
   textdelay := 0;
  end;
  SDL_BlitSurface(Background,nil,screen,nil);
  TTF_SetFontStyle(font,TTF_STYLE_UNDERLINE);
  WriteText(Screen,Font,'CREDITS',7,Screen.w div 2 - 50,40,0,color);
  TTF_SetFontStyle(font,TTF_STYLE_NORMAL);
  WriteText(Screen,font,tekst,nrofchars,60,80,0,color);
  SDL_Flip(Screen);
  SDL_Delay(Waitforframe);
 end;
 SDL_FreeSurface(Background);
end;
//End of credits

//Begin of Options

constructor TOptionSelector.Create;
begin
 image := IMG_Load(pchar(getapppath + 'Graphics\' + 'OptionsSelect.bmp'));
 SDL_SetColorKey(Image,SDL_SRCCOLORKEY or SDL_RLEACCEL or SDL_HWACCEL,SDL_MapRGB(Image.format,255,0,255));
 Selection := 1;
end;

procedure TOptionSelector.Draw;
var
 DstRect : TSDL_Rect;
begin
 Case Selection of
  1: DstRect.y := 80;
  2: DstRect.y := 120;
 end;
 Dstrect.x := 200;
 DstRect.w := image.w;
 DstRect.h := Image.h;
 SDL_BlitSurface(image,nil,screen,@DstRect);
end;

destructor TOptionSelector.Free;
begin
 SDL_FreeSurface(Image);
end;

procedure TOptionSelector.MoveDown;
begin
 if Selection < 2 then
 begin
  inc(Selection);
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Menu],0);
 end;
end;

procedure TOptionSelector.Moveup;
begin
 if Selection > 1 then
 begin
  Dec(Selection);
  if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Menu],0);
 end;
end;


Procedure Options;
var
 Background : PSDL_Surface;
 event : TSDL_Event;
 color : TSDL_Color;
 msg : String;
 Selector :ToptionSelector;
begin
 Background := IMG_Load(pchar(getapppath + 'graphics\' + 'paper.bmp'));
 Selector := ToptionSelector.Create;
 Color.r := 0;
 Color.b := 0;
 Color.g := 0;
 while Gamestate = GSOptions do
 begin
  While SDL_Pollevent(@event) > 0 do
  begin
   if (event.type_ = SDL_QUITEV) then
    GameState := GSQuit;
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_ESCAPE) then
    GameState := GSTitleScreen;
   if (event.type_ = SDL_KEYDOWN) and
      ((event.key.keysym.sym = SDLK_RETURN) or
       (event.key.keysym.sym = SDLK_SPACE)) then
       begin
        if selector.Selection = 1 then
        begin
         soundenabled := not soundenabled
        end
        else
        begin
         Musicenabled := not musicenabled;
         if not musicenabled then
          Mix_Haltmusic
         else
          Mix_PlayMusic(Music[MUS_Title],-1);
        end;
        if GlobalSoundEnabled and soundenabled then mix_playchannel(-1,sounds[SND_Select],0);
       end;
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_UP) then
       Selector.MoveUp;
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_DOWN) then
       Selector.MoveDOWN;
  end;
  SDL_Blitsurface(Background,nil,Screen,nil);
  TTF_SetFontStyle(font,TTF_STYLE_UNDERLINE);
  WriteText(Screen,Font,'OPTIONS',7,Screen.w div 2 - 50,40,0,color);
  TTF_SetFontStyle(font,TTF_STYLE_NORMAL);
  if SoundEnabled then
   msg := 'SOUND: ON'
  else
   msg := 'SOUND: OFF';
  WriteText(Screen,Font,msg,length(msg),Screen.w div 2 - 70,80,0,Color);
  If MusicEnabled then
   msg := 'MUSIC: ON'
  else
   msg := 'MUSIC: OFF';
  WriteText(Screen,Font,msg,length(msg),Screen.w div 2 - 70,120,0,Color);
  Selector.Draw;
  SDL_Flip(Screen);
  SDL_Delay(Waitforframe);
 end;
 Selector.free;
 SDL_FreeSurface(Background);
end;
//End of Options

//intialization & Finalasation stuff -----------------------------------
Procedure LoadImages;
var
 teller : integer;
begin
 for teller := 1 to Blockcount do
  blockimages[teller] := img_load(pchar(GetAppPath + 'Graphics\' + 'block' + inttostr(teller) + '.bmp'));
 for teller := 1 to BorderCount do
 begin
  BorderImages[teller] := Img_Load(pchar(GetAppPath + 'Graphics\' +'border' + inttostr(teller) + '.bmp'));
  SDL_SetColorkey(BorderImages[teller],SDL_RLEACCEL or SDL_HWACCEL or SDL_SRCCOLORKEY,SDL_MapRGB(borderimages[teller].format,255,0,255));
 end;
 RoomBackground := img_load(pchar(GetAppPath + 'Graphics\' +'roombackground.bmp'));
 StageClearKader := IMG_Load(pchar(GetAppPath + 'Graphics\' +'StageClearKader.bmp'));
 SDL_SetColorKey(StageClearKader,SDL_SRCCOLORKEY or SDL_RLEACCEL OR SDL_HWACCEL,SDL_MapRGB(StageClearKader.format,255,0,255));
 SDL_SetAlpha(StageClearKader,SDL_SRCALPHA,225);
 Bridge := IMG_Load(pchar(GetAppPath + 'Graphics\' +'Bridge.bmp'));
 SDL_SetColorKey(Bridge,SDL_SRCCOLORKEY OR SDL_RLEACCEL OR SDL_HWACCEL,SDL_MapRGB(Bridge.format,255,0,255));
end;

procedure UnLoadImages;
var
 teller : integer;
begin
 for teller := 1 to Blockcount do
  SDL_FreeSurface(blockimages[teller]);
 for teller := 1 to bordercount do
  SDL_FreeSurface(BorderImages[teller]);
 SDL_FreeSurface(RoomBackground);
 SDL_FreeSurface(StageClearKader);
 SDL_FreeSurface(Bridge);
end;

procedure unloadSounds;
var
 teller : integer;
begin
 for teller := 1 to NrofSounds do
  Mix_freechunk(sounds[teller]);
end;

procedure loadSounds;
begin
 sounds[SND_RotateBlock] := MIX_LOADWAV(pchar(getapppath + 'sounds\' + 'rotate.wav'));
 sounds[SND_DropBlock] := MIX_LoadWAv(pchar(getapppath + 'sounds\' + 'drop.wav'));
 sounds[SND_FlipBlock] := MIx_Loadwav(pchar(getapppath + 'sounds\' + 'rotate.wav'));
 sounds[SND_PickupBlock] := MIx_Loadwav(pchar(getapppath + 'sounds\' + 'pickup.wav'));
 sounds[SND_Error] := MIx_Loadwav(pchar(getapppath + 'sounds\' + 'error.wav'));
 sounds[SND_Menu] := MIx_Loadwav(pchar(getapppath + 'sounds\' + 'Menu.wav'));
 sounds[SND_Select] := Mix_Loadwav(pchar(getapppath + 'sounds\' + 'select.wav'));
 sounds[SND_Bridge] := Mix_Loadwav(pchar(getapppath + 'sounds\' + 'bridge.wav'));
 sounds[SND_StageEnd] := Mix_Loadwav(pchar(getapppath + 'sounds\' + 'stageend.wav'));
 sounds[SND_Elf] := Mix_Loadwav(pchar(getapppath + 'sounds\' + 'elf.wav'));
end;

Procedure LoadMusic;
begin
 Music[MUS_Title] := Mix_LoadMus(pchar(getapppath + 'music\' + 'title.ogg'));
 Music[MUS_game1] := Mix_LoadMus(pchar(getapppath + 'music\' + 'game1.ogg'));
 Music[MUS_game2] := Mix_LoadMus(pchar(getapppath + 'music\' + 'game2.ogg'));
 Music[MUS_Oldman] := Mix_LoadMus(pchar(getapppath + 'music\' + 'oldman.ogg'));
 Music[MUS_Stage] := Mix_LoadMus(pchar(getapppath + 'music\' + 'stage.ogg'));
end;

Procedure UnloadMusic;
var
 teller : integer;
begin
 Mix_HaltMusic;
 for teller := 1 to NrofMusic do
  Mix_FreeMusic(Music[teller]);
end;

Procedure Loadsettings;
var
 inifile:Tinifile;
begin
 inifile := Tinifile.Create(getapppath + 'settings.ini');
 SoundEnabled := Inifile.ReadBool('Settings','Sound',true);
 MusicEnabled := Inifile.ReadBool('Settings','Music',true);
 Inifile.Free;
end;

procedure SaveSettings;
var
 inifile:Tinifile;
begin
 inifile := Tinifile.Create(getapppath + 'settings.ini');
 Inifile.WriteBool('Settings','Sound',SoundEnabled);
 Inifile.writeBool('Settings','Music',MusicEnabled);
 Inifile.Free;
end;

begin
 if SDL_Init(SDL_INIT_VIDEO or SDL_INIT_AUDIO) = 0 then
 begin
  log.LogStatus('SDL Succesfully Initialized','Init');
  if paramstr(1) = 'windowed' then
   Screen := SDL_SetVideomode(640,480,16,SDL_HWSURFACE or SDL_LOGPAL)
  else
   Screen := SDL_SetVideomode(640,480,16,SDL_HWSURFACE or SDL_LOGPAL or SDL_DOUBLEBUF or SDL_FULLSCREEN );
  if screen <> nil then
  begin
   log.LogStatus('Video mode 640x480x16 Succesfully set','Init');
   if Mix_openaudio(MIX_DEFAULT_FREQUENCY,MIX_DEFAULT_FORMAT,MIX_DEFAULT_CHANNELS,1024)< 0 then
   begin
    GlobalSoundEnabled := false;
    log.logwarning(format('Failed to initialize audio: %s',[SDL_Geterror]),'Init');
   end
   else
    Log.LogStatus('Audio Succesfully Initialized','Init');
   LoadSettings;
   Loadsounds;
   LoadMusic;
   LongTimeFormat := 'hh:nn:ss';
   SDL_WM_SetCaption('Puzzle Land 1.0 Beta',nil);
   LoadImages;
   if TTF_Init = 0 then
   begin
    Log.LogStatus('Succesfully Initialized TTF','Init');
    Font := TTF_Openfont(Pchar(GetAppPath +'font.ttf'),40);
    if font <> nil then
    begin
     log.LogStatus('Succesfully Loaded font','Init');
     TTF_SetFontStyle(font,TTF_STYLE_NORMAL);
     While GameState <> GSQuit do
     begin
      Case GameState of
       GSGame : Game;
       GSStageClear : StageClear;
       GSNextStage : NextStage;
       GSPasswordEntry : PasswordEntry;
       GSTitleScreen: TitleScreen;
       GSStageSelect : StageSelect;
       GSIntro : Intro;
       GSOldmanSpeaking : OldmanSpeaking;
       GSCredits : Credits;
       GSOptions : Options;
      end;
     end;
     TTF_CloseFont(Font);
    end
    else
     log.LogError('Failed to Load font','init');
    TTF_Quit;
   end
   else
    log.LogError('Failed to initialize TTF','Init');
   Unloadimages;
   Mix_closeaudio;
   unLoadMusic;
   unloadsounds;
   SaveSettings;
   SDL_FreeSurface(screen);
  end
  else
  begin
   log.LogError(Format('Couldn''t Set video mode 640x480x16 : %s',[SDL_GetError]),'Init');
  end;
  SDL_Quit;
 end
 else
 begin
  MessageBox(0, PChar(Format('Couldn''t initialize SDL : %s',[SDL_GetError])), 'Error', MB_OK or MB_ICONHAND);
  log.LogError(Format('Couldn''t initialize SDL : %s',[SDL_GetError]),'Init');
 end;
end.
